Linux anchor 4.4.0-210-generic #242-Ubuntu SMP Fri Apr 16 09:57:56 UTC 2021 x86_64
Apache/2.4.18 (Ubuntu)
Server IP : 10.10.100.4 & Your IP : 216.73.217.150
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
sbin /
Delete
Unzip
Name
Size
Permission
Date
Action
a2disconf
15.06
KB
-rwxr-xr-x
2020-07-16 00:29
a2dismod
15.06
KB
-rwxr-xr-x
2020-07-16 00:29
a2dissite
15.06
KB
-rwxr-xr-x
2020-07-16 00:29
a2enconf
15.06
KB
-rwxr-xr-x
2020-07-16 00:29
a2enmod
15.06
KB
-rwxr-xr-x
2020-07-16 00:29
a2ensite
15.06
KB
-rwxr-xr-x
2020-07-16 00:29
a2query
9.64
KB
-rwxr-xr-x
2020-08-13 03:35
aa-exec
22.16
KB
-rwxr-xr-x
2023-06-29 13:30
aa-remove-unknown
2.86
KB
-rwxr-xr-x
2023-06-29 13:30
aa-status
7.11
KB
-rwxr-xr-x
2023-06-29 13:30
accessdb
10.23
KB
-rwxr-xr-x
2015-11-07 00:14
acpid
46.98
KB
-rwxr-xr-x
2016-04-09 00:36
add-shell
695
B
-rwxr-xr-x
2016-01-26 19:17
addgnupghome
3.01
KB
-rwxr-xr-x
2018-06-14 22:06
addgroup
36.4
KB
-rwxr-xr-x
2015-07-02 22:11
adduser
36.4
KB
-rwxr-xr-x
2015-07-02 22:11
apache2
647.03
KB
-rwxr-xr-x
2020-08-13 03:36
apache2ctl
6.25
KB
-rwxr-xr-x
2020-07-16 00:29
apachectl
6.25
KB
-rwxr-xr-x
2020-07-16 00:29
apparmor_status
7.11
KB
-rwxr-xr-x
2023-06-29 13:30
applygnupgdefaults
2.16
KB
-rwxr-xr-x
2018-06-14 22:06
arp
54.09
KB
-rwxr-xr-x
2014-06-30 15:19
arpd
46.74
KB
-rwxr-xr-x
2019-04-16 14:37
atd
26.01
KB
-rwxr-xr-x
2016-01-14 23:35
bcache-super-show
14.23
KB
-rwxr-xr-x
2015-06-27 01:10
biosdecode
18.82
KB
-rwxr-xr-x
2020-02-07 17:53
check_forensic
952
B
-rwxr-xr-x
2011-04-26 17:10
chgpasswd
53.33
KB
-rwxr-xr-x
2019-03-26 20:34
chpasswd
49.43
KB
-rwxr-xr-x
2019-03-26 20:34
chroot
38.8
KB
-rwxr-xr-x
2017-03-02 19:07
cifs.idmap
14.07
KB
-rwxr-xr-x
2017-03-06 14:02
cifs.upcall
30.07
KB
-rwxr-xr-x
2017-03-06 14:02
cpgr
51.48
KB
-rwxr-xr-x
2019-03-26 20:34
cppw
51.48
KB
-rwxr-xr-x
2019-03-26 20:34
cron
43.43
KB
-rwxr-xr-x
2016-04-05 23:59
cryptdisks_start
1.11
KB
-rwxr-xr-x
2017-09-06 12:08
cryptdisks_stop
1.16
KB
-rwxr-xr-x
2017-09-06 12:08
delgroup
16.13
KB
-rwxr-xr-x
2015-07-02 22:11
deluser
16.13
KB
-rwxr-xr-x
2015-07-02 22:11
dmidecode
102.49
KB
-rwxr-xr-x
2020-02-07 17:53
dnsmasq
363.35
KB
-rwxr-xr-x
2021-04-22 15:12
dpkg-divert
135.4
KB
-rwxr-xr-x
2021-04-20 22:48
dpkg-preconfigure
3.52
KB
-rwxr-xr-x
2019-05-08 20:33
dpkg-reconfigure
4.23
KB
-rwxr-xr-x
2019-05-08 20:33
dpkg-statoverride
59.08
KB
-rwxr-xr-x
2021-04-20 22:48
e2freefrag
10.24
KB
-rwxr-xr-x
2020-01-22 15:42
e4defrag
26.53
KB
-rwxr-xr-x
2020-01-22 15:42
ephemeral-disk-warning
982
B
-rwxr-xr-x
2019-05-23 23:15
fdformat
22.57
KB
-rwxr-xr-x
2020-01-27 15:28
filefrag
14.31
KB
-rwxr-xr-x
2020-01-22 15:42
genl
46.69
KB
-rwxr-xr-x
2019-04-16 14:37
groupadd
57.42
KB
-rwxr-xr-x
2019-03-26 20:34
groupdel
53.2
KB
-rwxr-xr-x
2019-03-26 20:34
groupmod
67.7
KB
-rwxr-xr-x
2019-03-26 20:34
grpck
53.31
KB
-rwxr-xr-x
2019-03-26 20:34
grpconv
49.19
KB
-rwxr-xr-x
2019-03-26 20:34
grpunconv
49.2
KB
-rwxr-xr-x
2019-03-26 20:34
grub-bios-setup
765.98
KB
-rwxr-xr-x
2021-04-30 18:02
grub-install
964.38
KB
-rwxr-xr-x
2021-04-30 18:02
grub-macbless
753.64
KB
-rwxr-xr-x
2021-04-30 18:02
grub-mkconfig
7.85
KB
-rwxr-xr-x
2021-04-30 18:00
grub-mkdevicemap
196.29
KB
-rwxr-xr-x
2021-04-30 18:02
grub-probe
765.92
KB
-rwxr-xr-x
2021-04-30 18:02
grub-reboot
4.02
KB
-rwxr-xr-x
2021-04-30 18:00
grub-set-default
3.48
KB
-rwxr-xr-x
2021-04-30 18:00
httxt2dbm
9.96
KB
-rwxr-xr-x
2020-08-13 03:36
hv_fcopy_daemon
1.58
KB
-rwxr-xr-x
2021-04-16 13:32
hv_get_dhcp_info
1.39
KB
-rwxr-xr-x
2021-04-16 13:32
hv_get_dns_info
622
B
-rwxr-xr-x
2021-04-16 13:32
hv_kvp_daemon
1.58
KB
-rwxr-xr-x
2021-04-16 13:32
hv_set_ifconfig
7.72
KB
-rwxr-xr-x
2021-04-16 13:32
hv_vss_daemon
1.58
KB
-rwxr-xr-x
2021-04-16 13:32
iconvconfig
26.66
KB
-rwxr-xr-x
2021-04-21 20:14
install-sgmlcatalog
4.44
KB
-rwxr-xr-x
2012-12-05 15:11
invoke-rc.d
19.41
KB
-rwxr-xr-x
2016-11-29 18:28
ip6tables-apply
6.85
KB
-rwxr-xr-x
2016-02-19 16:20
iptables-apply
6.85
KB
-rwxr-xr-x
2016-02-19 16:20
irqbalance
47.3
KB
-rwxr-xr-x
2016-04-11 19:56
iscsi-iname
13.99
KB
-rwxr-xr-x
2018-12-11 21:12
iscsi_discovery
5.16
KB
-rwxr-xr-x
2013-09-12 09:01
iscsid
765.61
KB
-rwxr-xr-x
2018-12-11 21:12
iscsistart
321.29
KB
-rwxr-xr-x
2018-12-11 21:12
laptop-detect
2.53
KB
-rwxr-xr-x
2010-03-06 15:44
ldattach
26.63
KB
-rwxr-xr-x
2020-01-27 15:28
locale-gen
4.3
KB
-rwxr-xr-x
2016-04-14 20:33
logrotate
63.11
KB
-rwxr-xr-x
2017-08-10 17:16
lsvmbus
1.58
KB
-rwxr-xr-x
2021-04-16 13:32
luksformat
3.2
KB
-rwxr-xr-x
2017-09-06 12:08
make-bcache
18.35
KB
-rwxr-xr-x
2015-06-27 01:10
make-ssl-cert
3.7
KB
-rwxr-xr-x
2015-08-16 19:14
mkinitramfs
10.24
KB
-rwxr-xr-x
2019-10-07 12:53
mklost+found
10.25
KB
-rwxr-xr-x
2020-01-22 15:42
mysqld
23.52
MB
-rwxr-xr-x
2021-01-28 17:23
newusers
73.84
KB
-rwxr-xr-x
2019-03-26 20:34
nfnl_osf
14.37
KB
-rwxr-xr-x
2016-02-19 16:21
nologin
5.95
KB
-rwxr-xr-x
2019-03-26 20:34
nscd
34.92
KB
-rwxr-xr-x
2016-03-20 11:25
ntp-keygen
66.91
KB
-rwxr-xr-x
2020-01-07 16:08
ntp-wait
3.13
KB
-rwxr-xr-x
2020-01-07 16:08
ntpd
717.27
KB
-rwxr-xr-x
2020-01-07 16:08
ntpdate
75.97
KB
-rwxr-xr-x
2020-01-07 16:08
ntpdate-debian
583
B
-rwxr-xr-x
2020-01-07 16:08
ntptime
14.31
KB
-rwxr-xr-x
2020-01-07 16:08
openvpn
674.28
KB
-rwxr-xr-x
2019-05-08 15:50
overlayroot-chroot
2.45
KB
-rwxr-xr-x
2018-10-01 19:50
ownership
10.13
KB
-rwxr-xr-x
2020-02-07 17:53
pam-auth-update
19.09
KB
-rwxr-xr-x
2020-10-01 02:33
pam_getenv
2.82
KB
-rwxr-xr-x
2020-10-01 02:33
pam_timestamp_check
10.38
KB
-rwxr-xr-x
2020-10-01 02:36
paperconfig
4.07
KB
-rwxr-xr-x
2015-11-04 12:21
phpdismod
7.11
KB
-rwxr-xr-x
2021-02-22 11:45
phpenmod
7.11
KB
-rwxr-xr-x
2021-02-22 11:45
phpquery
6.24
KB
-rwxr-xr-x
2021-02-22 11:45
popcon-largest-unused
543
B
-rwxr-xr-x
2016-02-26 20:55
popularity-contest
4.56
KB
-rwxr-xr-x
2016-02-26 20:55
postalias
17.87
KB
-rwxr-xr-x
2020-07-28 23:11
postcat
13.94
KB
-rwxr-xr-x
2020-07-28 23:11
postconf
171.16
KB
-rwxr-xr-x
2020-07-28 23:11
postdrop
13.99
KB
-r-xr-sr-x
2020-07-28 23:11
postfix
13.95
KB
-rwxr-xr-x
2020-07-28 23:11
postfix-add-filter
4.9
KB
-rwxr-xr-x
2020-07-28 23:11
postfix-add-policy
3.83
KB
-rwxr-xr-x
2020-07-28 23:11
postkick
9.87
KB
-rwxr-xr-x
2020-07-28 23:11
postlock
9.87
KB
-rwxr-xr-x
2020-07-28 23:11
postlog
10.02
KB
-rwxr-xr-x
2020-07-28 23:11
postmap
17.87
KB
-rwxr-xr-x
2020-07-28 23:11
postmulti
26.26
KB
-rwxr-xr-x
2020-07-28 23:11
postqueue
17.95
KB
-r-xr-sr-x
2020-07-28 23:11
postsuper
22.2
KB
-rwxr-xr-x
2020-07-28 23:11
posttls-finger
33.95
KB
-rwxr-xr-x
2020-07-28 23:11
pwck
45.36
KB
-rwxr-xr-x
2019-03-26 20:34
pwconv
41.27
KB
-rwxr-xr-x
2019-03-26 20:34
pwunconv
36.43
KB
-rwxr-xr-x
2019-03-26 20:34
qmqp-sink
13.87
KB
-rwxr-xr-x
2020-07-28 23:11
qmqp-source
17.88
KB
-rwxr-xr-x
2020-07-28 23:11
qshape
12.55
KB
-rwxr-xr-x
2020-07-28 23:11
readprofile
14.52
KB
-rwxr-xr-x
2020-01-27 15:28
remove-shell
749
B
-rwxr-xr-x
2016-01-26 19:17
rmail
13.87
KB
-rwxr-xr-x
2020-07-28 23:11
rmt
54.95
KB
-rwxr-xr-x
2021-01-11 18:30
rmt-tar
54.95
KB
-rwxr-xr-x
2021-01-11 18:30
rsyslogd
585.28
KB
-rwxr-xr-x
2019-03-25 14:14
rtcwake
38.8
KB
-rwxr-xr-x
2020-01-27 15:28
safe_finger
10.35
KB
-rwxr-xr-x
2014-01-13 00:11
samba_kcc
10.72
KB
-rwxr-xr-x
2021-04-14 18:00
sendmail
26.02
KB
-rwxr-xr-x
2020-07-28 23:11
service
9.82
KB
-rwxr-xr-x
2016-09-12 10:57
setvesablank
10.27
KB
-rwxr-xr-x
2016-09-22 19:33
smtp-sink
30.8
KB
-rwxr-xr-x
2020-07-28 23:11
smtp-source
21.89
KB
-rwxr-xr-x
2020-07-28 23:11
spfd
17.96
KB
-r-xr-xr-x
2017-10-05 13:57
split-logfile
2.36
KB
-rwxr-xr-x
2020-08-13 03:34
sshd
772.48
KB
-rwxr-xr-x
2020-05-27 01:17
tarcat
936
B
-rwxr-xr-x
2021-01-11 18:30
tcpd
10.21
KB
-rwxr-xr-x
2014-01-13 00:11
tcpdchk
22.51
KB
-rwxr-xr-x
2014-01-13 00:11
tcpdmatch
18.42
KB
-rwxr-xr-x
2014-01-13 00:11
tcpdump
1007.6
KB
-rwxr-xr-x
2020-01-24 15:00
try-from
10.16
KB
-rwxr-xr-x
2014-01-13 00:11
tunelp
22.53
KB
-rwxr-xr-x
2020-01-27 15:28
tzconfig
106
B
-rwxr-xr-x
2016-01-21 18:04
ufw
4.4
KB
-rwxr-xr-x
2016-04-15 07:16
update-alternatives
46.61
KB
-rwxr-xr-x
2021-04-20 22:48
update-ca-certificates
5.16
KB
-rwxr-xr-x
2021-02-01 17:16
update-catalog
9.15
KB
-rwxr-xr-x
2012-12-05 15:11
update-grub
64
B
-rwxr-xr-x
2020-08-24 10:54
update-grub-gfxpayload
301
B
-rwxr-xr-x
2015-03-27 18:50
update-grub2
64
B
-rwxr-xr-x
2020-08-24 10:54
update-gsfontmap
450
B
-rwxr-xr-x
2021-01-06 20:23
update-info-dir
1.66
KB
-rwxr-xr-x
2016-03-12 10:46
update-initramfs
8.38
KB
-rwxr-xr-x
2019-10-07 12:53
update-locale
2.99
KB
-rwxr-xr-x
2016-01-27 15:17
update-mime
8.84
KB
-rwxr-xr-x
2015-10-30 16:39
update-passwd
30.41
KB
-rwxr-xr-x
2016-01-03 00:13
update-pciids
2.84
KB
-rwxr-xr-x
2019-02-11 14:13
update-rc.d
14.1
KB
-rwxr-xr-x
2016-02-29 13:24
update-usbids
1.05
KB
-rwxr-xr-x
2015-10-23 23:56
update-xmlcatalog
16.28
KB
-rwxr-xr-x
2012-11-07 22:44
upgrade-from-grub-legacy
1.49
KB
-rwxr-xr-x
2020-08-24 10:54
useradd
118.72
KB
-rwxr-xr-x
2019-03-26 20:34
userdel
81.92
KB
-rwxr-xr-x
2019-03-26 20:34
usermod
118.5
KB
-rwxr-xr-x
2019-03-26 20:34
uuidd
30.73
KB
-rwxr-xr-x
2020-01-27 15:28
validlocale
1.73
KB
-rwxr-xr-x
2016-01-27 15:17
vcstime
6.26
KB
-rwxr-xr-x
2016-09-22 19:33
vigr
55.7
KB
-rwxr-xr-x
2019-03-26 20:34
vipw
55.7
KB
-rwxr-xr-x
2019-03-26 20:34
visudo
187.89
KB
-rwxr-xr-x
2021-01-20 18:08
vpddecode
14.27
KB
-rwxr-xr-x
2020-02-07 17:53
waagent
1.48
KB
-rwxr-xr-x
2020-01-30 18:10
waagent2.0
246.41
KB
-rwxr-xr-x
2020-01-30 18:10
xfs_admin
1.35
KB
-rwxr-xr-x
2017-09-08 22:23
xfs_bmap
638
B
-rwxr-xr-x
2017-09-08 22:23
xfs_copy
335.02
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_db
548.46
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_estimate
10.26
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_freeze
767
B
-rwxr-xr-x
2017-09-08 22:23
xfs_fsr
30.68
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_growfs
323.02
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_info
472
B
-rwxr-xr-x
2017-09-08 22:23
xfs_io
119.72
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_logprint
351.3
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_mdrestore
310.94
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_metadump
747
B
-rwxr-xr-x
2017-09-08 22:23
xfs_mkfile
1007
B
-rwxr-xr-x
2017-09-08 22:23
xfs_ncheck
650
B
-rwxr-xr-x
2017-09-08 22:23
xfs_quota
82.69
KB
-rwxr-xr-x
2017-09-08 22:24
xfs_rtcp
14.34
KB
-rwxr-xr-x
2017-09-08 22:24
zerofree
10.16
KB
-rwxr-xr-x
2014-05-06 13:01
zic
50.54
KB
-rwxr-xr-x
2021-04-21 20:14
Save
Rename
#!/bin/sh umask 0022 export PATH='/usr/bin:/sbin:/bin' # Defaults keep="n" CONFDIR="/etc/initramfs-tools" verbose="n" test -e /bin/busybox && BUSYBOXDIR=/bin test -e /usr/lib/initramfs-tools/bin/busybox && BUSYBOXDIR=/usr/lib/initramfs-tools/bin export BUSYBOXDIR OPTIONS=`getopt -o c:d:ko:r:v -n "$0" -- "$@"` # Check for non-GNU getopt if [ $? != 0 ] ; then echo "W: non-GNU getopt" >&2 ; exit 1 ; fi eval set -- "$OPTIONS" while true; do case "$1" in -c) compress="$2" shift 2 ;; -d) CONFDIR="$2" shift 2 if [ ! -d "${CONFDIR}" ]; then echo "${0}: ${CONFDIR}: Not a directory" >&2 exit 1 fi ;; -o) outfile="$2" shift 2 ;; -k) keep="y" shift ;; -r) ROOT="$2" shift 2 ;; -v) verbose="y" shift ;; --) shift break ;; *) echo "Internal error!" >&2 exit 1 ;; esac done # For dependency ordered mkinitramfs hook scripts. . /usr/share/initramfs-tools/scripts/functions . /usr/share/initramfs-tools/hook-functions . "${CONFDIR}/initramfs.conf" EXTRA_CONF='' for i in /usr/share/initramfs-tools/conf.d/* ${CONFDIR}/conf.d/*; do [ -e $i ] && EXTRA_CONF="${EXTRA_CONF} $(basename $i \ | grep '^[[:alnum:]][[:alnum:]\._-]*$' | grep -v '\.dpkg-.*$')"; done # FIXME: deprecated those settings on mkinitramfs run # these conf dirs are for boot scripts and land on initramfs for i in ${EXTRA_CONF}; do if [ -d ${CONFDIR}/conf.d/${i} ]; then echo "Warning: ${CONFDIR}/conf.d/${i} is a directory instead of file, ignoring." elif [ -e ${CONFDIR}/conf.d/${i} ]; then . ${CONFDIR}/conf.d/${i} elif [ -e /usr/share/initramfs-tools/conf.d/${i} ]; then . /usr/share/initramfs-tools/conf.d/${i} fi done # source package confs for i in /usr/share/initramfs-tools/conf-hooks.d/*; do if [ -d "${i}" ]; then echo "Warning: ${i} is a directory instead of file, ignoring." elif [ -e "${i}" ]; then . "${i}" fi done if [ -n "${UMASK:-}" ]; then umask "${UMASK}" fi if [ -z "${outfile}" ]; then usage fi touch "$outfile" outfile="$(readlink -f "$outfile")" # And by "version" we really mean path to kernel modules # This is braindead, and exists to preserve the interface with mkinitrd if [ ${#} -ne 1 ]; then version="$(uname -r)" else version="${1}" fi case "${version}" in /lib/modules/*/[!/]*) ;; /lib/modules/[!/]*) version="${version#/lib/modules/}" version="${version%%/*}" ;; esac case "${version}" in */*) echo "$PROG: ${version} is not a valid kernel version" >&2 exit 1 ;; esac # Check userspace and kernel support for compressed initramfs images if [ -z "${compress:-}" ]; then compress=${COMPRESS} else COMPRESS=${compress} fi if ! command -v "${compress}" >/dev/null 2>&1; then compress=gzip [ "${verbose}" = y ] && \ echo "No ${COMPRESS} in ${PATH}, using gzip" COMPRESS=gzip fi if dpkg --compare-versions "${version}" lt "2.6.38" 2>/dev/null; then compress=gzip [ "${verbose}" = y ] && \ echo "linux-2.6 likely misses ${COMPRESS} support, using gzip" fi [ "${compress}" = lzop ] && compress="lzop -9" [ "${compress}" = xz ] && compress="xz --check=crc32" if [ -d "${outfile}" ]; then echo "${outfile} is a directory" >&2 exit 1 fi MODULESDIR="/lib/modules/${version}" if [ ! -e "${MODULESDIR}" ]; then echo "WARNING: missing ${MODULESDIR}" echo "Ensure all necessary drivers are built into the linux image!" fi if [ ! -e "${MODULESDIR}/modules.dep" ]; then depmod ${version} fi # Prepare to clean up temporary files on exit DESTDIR= __TMPCPIOGZ= __TMPEARLYCPIO= clean_on_exit() { if [ "${keep}" = "y" ]; then echo "Working files in ${DESTDIR:-<not yet created>}, early initramfs in ${__TMPEARLYCPIO:-<not yet created>} and overlay in ${__TMPCPIOGZ:-<not yet created>}" else for path in "${DESTDIR}" "${__TMPCPIOGZ}" "${__TMPEARLYCPIO}"; do test -z "${path}" || rm -rf "${path}" done fi } trap clean_on_exit EXIT trap "exit 1" INT TERM # makes the EXIT trap effective even when killed # Create temporary directory and files for initramfs contents [ -n "${TMPDIR}" ] && [ ! -w "${TMPDIR}" ] && unset TMPDIR DESTDIR="$(mktemp -d ${TMPDIR:-/var/tmp}/mkinitramfs_XXXXXX)" || exit 1 chmod 755 "${DESTDIR}" __TMPCPIOGZ="$(mktemp ${TMPDIR:-/var/tmp}/mkinitramfs-OL_XXXXXX)" || exit 1 __TMPEARLYCPIO="$(mktemp ${TMPDIR:-/var/tmp}/mkinitramfs-FW_XXXXXX)" || exit 1 DPKG_ARCH=`dpkg --print-architecture` # Export environment for hook scripts. # export MODULESDIR export version export CONFDIR export DESTDIR export DPKG_ARCH export verbose export MODULES export BUSYBOX export COMPCACHE_SIZE # Private, used by 'catenate_cpiogz'. export __TMPCPIOGZ # Private, used by 'prepend_earlyinitramfs'. export __TMPEARLYCPIO for d in bin conf/conf.d etc lib/modules run sbin scripts ${MODULESDIR}; do mkdir -p "${DESTDIR}/${d}" done # Copy in modules.builtin and modules.order (not generated by depmod) for x in modules.builtin modules.order; do if [ -f "${MODULESDIR}/${x}" ]; then cp -p "${MODULESDIR}/${x}" "${DESTDIR}${MODULESDIR}/${x}" fi done # MODULES=list case. Always honour. for x in "${CONFDIR}/modules" /usr/share/initramfs-tools/modules.d/*; do if [ -f "${x}" ]; then add_modules_from_file "${x}" fi done # MODULES=most is default case "${MODULES}" in dep) dep_add_modules ;; most) auto_add_modules ;; netboot) auto_add_modules base auto_add_modules net ;; list) # nothing to add ;; *) echo "W: mkinitramfs: unsupported MODULES setting: ${MODULES}." echo "W: mkinitramfs: Falling back to MODULES=most." auto_add_modules ;; esac # Resolve hidden dependencies hidden_dep_add_modules # First file executed by linux cp -p /usr/share/initramfs-tools/init ${DESTDIR}/init # add existant boot scripts for b in $(cd /usr/share/initramfs-tools/scripts/ && find . \ -regextype posix-extended -regex '.*/[[:alnum:]\._-]+$' -type f); do option=$(sed '/^OPTION=/!d;$d;s/^OPTION=//;s/[[:space:]]*$//' "/usr/share/initramfs-tools/scripts/${b}") [ -z "${option}" ] || eval test -n \"\${$option}\" -a \"\${$option}\" != \"n\" || continue [ -d "${DESTDIR}/scripts/$(dirname "${b}")" ] \ || mkdir -p "${DESTDIR}/scripts/$(dirname "${b}")" cp -p "/usr/share/initramfs-tools/scripts/${b}" \ "${DESTDIR}/scripts/$(dirname "${b}")/" done for b in $(cd "${CONFDIR}/scripts" && find . \ -regextype posix-extended -regex '.*/[[:alnum:]\._-]+$' -type f); do option=$(sed '/^OPTION=/!d;$d;s/^OPTION=//;s/[[:space:]]*$//' "${CONFDIR}/scripts/${b}") [ -z "${option}" ] || eval test -n \"\${$option}\" -a \"\${$option}\" != \"n\" || continue [ -d "${DESTDIR}/scripts/$(dirname "${b}")" ] \ || mkdir -p "${DESTDIR}/scripts/$(dirname "${b}")" cp -p "${CONFDIR}/scripts/${b}" "${DESTDIR}/scripts/$(dirname "${b}")/" done echo "DPKG_ARCH=${DPKG_ARCH}" > ${DESTDIR}/conf/arch.conf cp -p "${CONFDIR}/initramfs.conf" ${DESTDIR}/conf for i in ${EXTRA_CONF}; do if [ -e "${CONFDIR}/conf.d/${i}" ]; then copy_file config "${CONFDIR}/conf.d/${i}" /conf/conf.d elif [ -e "/usr/share/initramfs-tools/conf.d/${i}" ]; then copy_file config "/usr/share/initramfs-tools/conf.d/${i}" \ /conf/conf.d fi done # ROOT hardcoding if [ -n "${ROOT:-}" ]; then echo "ROOT=${ROOT}" > ${DESTDIR}/conf/conf.d/root fi if ! command -v ldd >/dev/null 2>&1 ; then echo "WARNING: no ldd around - install libc-bin" >&2 exit 1 fi # fstab and mtab touch "${DESTDIR}/etc/fstab" ln -s /proc/mounts "${DESTDIR}/etc/mtab" # install wait-for-root binary. copy_exec /usr/lib/initramfs-tools/bin/wait-for-root /sbin # module-init-tools copy_exec /sbin/modprobe /sbin copy_exec /sbin/rmmod /sbin mkdir -p "${DESTDIR}/etc/modprobe.d" cp -a /etc/modprobe.d/* "${DESTDIR}/etc/modprobe.d/" # workaround: libgcc always needed on old-abi arm if [ "$DPKG_ARCH" = arm ] || [ "$DPKG_ARCH" = armeb ]; then cp -a /lib/libgcc_s.so.1 "${DESTDIR}/lib/" fi run_scripts_optional /usr/share/initramfs-tools/hooks run_scripts_optional "${CONFDIR}"/hooks # cache boot run order for b in $(cd "${DESTDIR}/scripts" && find . -mindepth 1 -type d); do cache_run_scripts "${DESTDIR}" "/scripts/${b#./}" done # generate module deps depmod -a -b "${DESTDIR}" ${version} rm -f "${DESTDIR}/lib/modules/${version}"/modules.*map # make sure that library search path is up to date cp -ar /etc/ld.so.conf* "$DESTDIR"/etc/ if ! ldconfig -r "$DESTDIR" ; then [ $(id -u) != "0" ] \ && echo "ldconfig might need uid=0 (root) for chroot()" >&2 fi # Apply DSDT to initramfs if [ -e "${CONFDIR}/DSDT.aml" ]; then copy_file DSDT "${CONFDIR}/DSDT.aml" fi # Make sure there is a final sh in initramfs if [ ! -e "${DESTDIR}/bin/sh" ]; then copy_exec /bin/sh "${DESTDIR}/bin/" fi # Remove any looping or broken symbolic links, since they break cpio. [ "${verbose}" = y ] && xargs_verbose="-t" (cd "${DESTDIR}" && find . -type l -printf '%p %Y\n' | sed -n 's/ [LN]$//p' \ | xargs ${xargs_verbose:-} -rL1 rm -f) # dirty hack for armhf's double-linker situation; if we have one of # the two known eglibc linkers, nuke both and re-create sanity if [ "$DPKG_ARCH" = armhf ]; then if [ -e "${DESTDIR}/lib/arm-linux-gnueabihf/ld-linux.so.3" ] || \ [ -e "${DESTDIR}/lib/ld-linux-armhf.so.3" ]; then rm -f "${DESTDIR}/lib/arm-linux-gnueabihf/ld-linux.so.3" rm -f "${DESTDIR}/lib/ld-linux-armhf.so.3" cp -aL /lib/ld-linux-armhf.so.3 "${DESTDIR}/lib/" ln -sf /lib/ld-linux-armhf.so.3 "${DESTDIR}/lib/arm-linux-gnueabihf/ld-linux.so.3" fi fi [ "${verbose}" = y ] && echo "Building cpio ${outfile} initramfs" if [ -s "${__TMPEARLYCPIO}" ]; then cat "${__TMPEARLYCPIO}" >"${outfile}" || exit 1 else # truncate > "${outfile}" fi ( # preserve permissions if root builds the image, see #633582 [ "$(id -ru)" != 0 ] && cpio_owner_root="-R 0:0" # work around lack of "set -o pipefail" for the following pipe: # cd "${DESTDIR}" && find . | cpio --quiet $cpio_owner_root -o -H newc | gzip >>"${outfile}" || exit 1 exec 3>&1 eval ` # http://cfaj.freeshell.org/shell/cus-faq-2.html exec 4>&1 >&3 3>&- cd "${DESTDIR}" { find . 4>&-; echo "ec1=$?;" >&4 } | { cpio --quiet $cpio_owner_root -o -H newc 4>&-; echo "ec2=$?;" >&4 } | ${compress} >>"${outfile}" echo "ec3=$?;" >&4 ` if [ "$ec1" -ne 0 ]; then echo "E: mkinitramfs failure find $ec1 cpio $ec2 $compress $ec3" exit "$ec1" fi if [ "$ec2" -ne 0 ]; then echo "E: mkinitramfs failure cpio $ec2 $compress $ec3" exit "$ec2" fi if [ "$ec3" -ne 0 ]; then echo "E: mkinitramfs failure $compress $ec3" exit "$ec3" fi ) || exit 1 if [ -s "${__TMPCPIOGZ}" ]; then cat "${__TMPCPIOGZ}" >>"${outfile}" || exit 1 fi exit 0